<template>
  <div class="code-mirror" ref="code-mirror"></div>
</template>
<style scoped>
.code-mirror {
  height: 100%;
}
</style>
<script>
import "codemirror/lib/codemirror.css";
import "codemirror/mode/sql/sql.js";
import CodeMirror from "codemirror";
export default {
  name: "Component-CodeMirror",
  props: {
    itemTab: Object
  },
  data: () => ({
    instanceCodeMirror: null
  }),
  computed: {
    codeValue() {
      if (this.instanceCodeMirror) {
        return this.instanceCodeMirror.getValue();
      } else {
        return null;
      }
    }
  },
  methods: {
    init() {
      let codeMirrorElement;
      this.$nextTick(() => {
        codeMirrorElement = this.$refs["code-mirror"];
        this.initCodeMirror(codeMirrorElement);
      });
    },
    initCodeMirror(codeMirrorElement) {
      this.instanceCodeMirror = CodeMirror(codeMirrorElement, {
        mode: "text/x-plsql",
        lineNumbers: true
      });
      this.instanceCodeMirror.setSize("100%", "100%");
      this.instanceCodeMirror.on("change", (codeMirror) => {
        const value = codeMirror.getValue();
        this.itemTab.setPlsql(value, this.itemTab);
      });
    }
  },
  created() {
    this.init();
  }
};
</script>
